import sys
global AdminConfig
#
#olaRar.py requires 2 parameters. They are cell_name and application_server_node_name.
#
#olaRar.py sets WAS_DAEMON_ONLY_enable_adapter to true, 
#          installs the ola.rar Resource Adapter and
#          creates a J2C connection factory
#
#Sample base invocation with olaRar.py in the root directory. Application server needs to be running.
#/WebSphere/V7R0/AppServer/profiles/default/bin/wsadmin.sh -lang jython -f /olaRar.py SY1 SY1
#
#Sample ND invocation with olaRar.py in the root directory. Deployment manager needs to be running.
#/WebSphere/V7R0/DeploymentManager/profiles/default/bin/wsadmin.sh -lang jython -f /olaRar.py PLEX1Network SY1


def enable_adapter ( map, var, val ):

    attrs = [[ "symbolicName", var ], [ "value", val ]]
    serverVariables = AdminConfig.list("VariableSubstitutionEntry", map).split("\n")
    currentValue = ""
    for variable in serverVariables:
        variable = variable.rstrip()
        variableName = AdminConfig.showAttribute(variable, "symbolicName")
        if (variableName == attrs[0][1]):
            AdminConfig.modify(variable, attrs)
            currentValue = variable

    # Add the property if it wasn't found
    if (len(currentValue) == 0):
        AdminConfig.create("VariableSubstitutionEntry", map, attrs)


#endDef




len_args = len(sys.argv)
if (len_args  == 2):
    cellName = sys.argv[0]
    nodeName = sys.argv[1]

    variableMap = ""
    variableMap = AdminConfig.getid("/Node:"+nodeName+"/VariableMap:/")
    if (len(variableMap) != 0):
        nodeVariables = AdminConfig.list("VariableSubstitutionEntry", variableMap).split("\n")
        #WAS_INSTALL_ROOT
        therarPath = ""
        for variable in nodeVariables:
            variable = variable.rstrip()
            variableName = AdminConfig.showAttribute(variable, "symbolicName")
            if (variableName == "WAS_HOME"):
                therarPath = AdminConfig.showAttribute(variable, "value")

        if (len(therarPath) != 0):
            VALUE = "true"
            VARIABLE = "WAS_DAEMON_ONLY_enable_adapter"
            MAP = ""
            MAP = AdminConfig.getid("/Cell:"+cellName+"/VariableMap:/")
            if (len(MAP) != 0):
                print ""
                print "setting WAS_DAEMON_ONLY_enable_adapter = true"
                enable_adapter(MAP, VARIABLE, VALUE )

                print ""
                print "Installing resource adapter"
                AdminTask.installResourceAdapter('[-nodeName '+nodeName+' -rarPath '+therarPath+'/installableApps/ola.rar -rar.name OptimizedLocalAdapter -rar.desc "OLA " -rar.archivePath ${CONNECTOR_INSTALL_ROOT} ]')

                print ""
                print "create J2C connection factory"
                newra = AdminConfig.getid("/Cell:"+cellName+"/Node:"+nodeName+"/J2CResourceAdapter:OptimizedLocalAdapter/")
                AdminTask.createJ2CConnectionFactory(newra, '[-connectionFactoryInterface javax.resource.cci.ConnectionFactory -name ola -jndiName eis/ola -description -authDataAlias ]')

                print ""
                print "Validating configuration..."
                AdminConfig.validate()
                print "Saving configuration changes..."
                AdminConfig.save()
            else:
                print ""
                print 'ERROR: Variable map not found for cell ', cellName
        else:
            print ""
            print 'ERROR: WAS_HOME not found for node ', nodeName
    else:
        print ""
        print 'ERROR: Variable map not found for node ', nodeName
else:
    print ""
    print 'The number of parameters passed in:', len_args
    print "ERROR: Wrong number of parameters. Please try again with cell name and application server node name."

