###############################################################################
# Licensed Material - Property of IBM 
# 5724-I63, 5724-H88, (C) Copyright IBM Corp. 2010 - All Rights Reserved. 
# US Government Users Restricted Rights - Use, duplication or disclosure 
# restricted by GSA ADP Schedule Contract with IBM Corp. 
#
# DISCLAIMER:
# The following source code is sample code created by IBM Corporation.
# This sample code is provided to you solely for the purpose of assisting you 
# in the  use of  the product. The code is provided 'AS IS', without warranty or 
# condition of any kind. IBM shall not be liable for any damages arising out of your
# use of the sample code, even if IBM has been advised of the possibility of
# such damages.
###############################################################################
import sys

global AdminConfig

#
#olaRarUpdate.py requires 2 parameters. They are cell_name and application_server_node_name.
#
#olaRarUpdate.py will refresh the ola.rar on your node
#
#Sample base invocation with olaRarUpdate.py in the root directory. Application server needs to be running.
#/WebSphere/V7R0/AppServer/profiles/default/bin/wsadmin.sh -lang jython -f /olaRarUpdate.py SY1 SY1
#
#Sample ND invocation with olaRar.py in the root directory. Deployment manager needs to be running.
#/WebSphere/V7R0/DeploymentManager/profiles/default/bin/wsadmin.sh -lang jython -f /olaRarUpdate.py PLEX1Network SY1

DEBUG = 0

def debug(theText):
    if (DEBUG != 0):
        print(theText)

def resolveVariableName(nodeVariables, nameToLookup):
    debug("Called resolveVariableName with string " + nameToLookup)
    result = nameToLookup
    startBraceIndex = nameToLookup.find("${")
    if (startBraceIndex > -1):
        endBraceIndex = nameToLookup.find("}")
        if (endBraceIndex > -1):
            variableToFind = nameToLookup[startBraceIndex+2:endBraceIndex]
            debug("Found variable " + variableToFind)
            for variable in nodeVariables:
                variable = variable.rstrip()
                variableName = AdminConfig.showAttribute(variable, \
                                                         "symbolicName")
                if (variableName == variableToFind):
                    variableValue = AdminConfig.showAttribute(variable, \
                                                              "value")
                    debug("Replacing " + variableToFind + " with " + variableValue)
                    result = resolveVariableName(nodeVariables, \
                       nameToLookup.replace("${" + variableToFind + "}",\
                                            variableValue))
                    break
    return result
                

len_args = len(sys.argv)
if (len_args  == 2):
    cellName = sys.argv[0]
    nodeName = sys.argv[1]

    variableMap = ""
    variableMap = AdminConfig.getid("/Node:"+nodeName+"/VariableMap:/")
    if (len(variableMap) != 0):
        nodeVariables = AdminConfig.list("VariableSubstitutionEntry", variableMap).split("\n")
        #WAS_INSTALL_ROOT
        therarPath = resolveVariableName(nodeVariables, "${WAS_HOME}")

        if (len(therarPath) != 0):
            numResourceAdaptersUpdated = 0
            print ""
            print "Looking for resource adapters to update"

            ras = AdminJ2C.listJ2CResourceAdapters()
            if (len(ras) > 0):
                for ra in ras:
                    isCompatible = AdminTask.compareResourceAdapterToRAR(ra, '[-rarPath ' + therarPath + '/installableApps/ola.rar]')
                    if (isCompatible.startswith("true")):
                        print ""
                        print "Updating installed RAR " + ra
                        AdminTask.updateRAR(ra, '[-rarPath ' + therarPath + '/installableApps/ola.rar]')
                        numResourceAdaptersUpdated = numResourceAdaptersUpdated + 1

                print "Validating configuration..."
                AdminConfig.validate()
                print "Saving configuration changes..."
                AdminConfig.save()
                print str(numResourceAdaptersUpdated) + " resource adapters were updated"
            else:
                print ""
                print 'ERROR: Variable map not found for cell ', cellName
        else:
            print ""
            print 'ERROR: WAS_HOME not found for node ', nodeName
    else:
        print ""
        print 'ERROR: Variable map not found for node ', nodeName
else:
    print ""
    print 'The number of parameters passed in:', len_args
    print "ERROR: Wrong number of parameters. Please try again with cell name and application server node name."

